<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.handle package &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="lib.inout package" href="lib.inout.html" />
    <link rel="prev" title="lib.fit package" href="lib.fit.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="lib.html">lib package</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="lib.fit.html">lib.fit package</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">lib.handle package</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#module-lib.handle.handle_array">lib.handle.handle_array module</a></li>
<li class="toctree-l3"><a class="reference internal" href="#module-lib.handle.handle_dict">lib.handle.handle_dict module</a></li>
<li class="toctree-l3"><a class="reference internal" href="#module-lib.handle.handle_hist">lib.handle.handle_hist module</a></li>
<li class="toctree-l3"><a class="reference internal" href="#module-lib.handle.handle_list">lib.handle.handle_list module</a></li>
<li class="toctree-l3"><a class="reference internal" href="#module-lib.handle.handle_sample">lib.handle.handle_sample module</a></li>
<li class="toctree-l3"><a class="reference internal" href="#module-lib.handle.handle_str">lib.handle.handle_str module</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="lib.inout.html">lib.inout package</a></li>
<li class="toctree-l2"><a class="reference internal" href="lib.plot.html">lib.plot package</a></li>
<li class="toctree-l2"><a class="reference internal" href="lib.html#module-lib.assertion">lib.assertion module</a></li>
<li class="toctree-l2"><a class="reference internal" href="lib.html#module-lib.config">lib.config module</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="lib.html">lib package</a> &raquo;</li>
      <li>lib.handle package</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/lib.handle.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <div class="section" id="module-lib.handle">
<span id="lib-handle-package"></span><h1>lib.handle package<a class="headerlink" href="#module-lib.handle" title="Permalink to this heading"></a></h1>
<p>Package to handle python objects such as arrays, dictionnaries, etc.</p>
<div class="section" id="module-lib.handle.handle_array">
<span id="lib-handle-handle-array-module"></span><h2>lib.handle.handle_array module<a class="headerlink" href="#module-lib.handle.handle_array" title="Permalink to this heading"></a></h2>
<p>Module to process arrays.</p>
<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_array.compute_avg_ufloat">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_array.</span></span><span class="sig-name descname"><span class="pre">compute_avg_ufloat</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">array</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_array.html#compute_avg_ufloat"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_array.compute_avg_ufloat" title="Permalink to this definition"></a></dt>
<dd><p>Compute the average of ann array of <cite>ufloat</cite>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>array</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>) – array of ufloat</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">ufloat</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>average of <code class="docutils literal notranslate"><span class="pre">array</span></code>, weighted by the weights</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_array.compute_weighted_avg">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_array.</span></span><span class="sig-name descname"><span class="pre">compute_weighted_avg</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">array</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">weights</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_array.html#compute_weighted_avg"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_array.compute_weighted_avg" title="Permalink to this definition"></a></dt>
<dd><p>Compute weighted average. Support ufloat arrays.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>array</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>]) – array</p></li>
<li><p><strong>weights</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>]) – array of weights</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>average of <code class="docutils literal notranslate"><span class="pre">array</span></code> weighted by <code class="docutils literal notranslate"><span class="pre">weights</span></code></p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="module-lib.handle.handle_dict">
<span id="lib-handle-handle-dict-module"></span><h2>lib.handle.handle_dict module<a class="headerlink" href="#module-lib.handle.handle_dict" title="Permalink to this heading"></a></h2>
<p>Module to handle dictionnaries.</p>
<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_dict.invert_keys_values">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_dict.</span></span><span class="sig-name descname"><span class="pre">invert_keys_values</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dic</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_dict.html#invert_keys_values"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_dict.invert_keys_values" title="Permalink to this definition"></a></dt>
<dd><p>Invert the key and values of a dictionnary. Not in place.</p>
<dl class="field-list simple">
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">dict</span></code></p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="module-lib.handle.handle_hist">
<span id="lib-handle-handle-hist-module"></span><h2>lib.handle.handle_hist module<a class="headerlink" href="#module-lib.handle.handle_hist" title="Permalink to this heading"></a></h2>
<p>Module to build histograms.</p>
<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_hist.dataframes_into_hist_1d">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_hist.</span></span><span class="sig-name descname"><span class="pre">dataframes_into_hist_1d</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">samples</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">column</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">bins</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">50</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">low</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">high</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">weights</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">density</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">equal_yield_bins</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_hist.html#dataframes_into_hist_1d"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_hist.dataframes_into_hist_1d" title="Permalink to this definition"></a></dt>
<dd><p>Turn a list of dataframes into a histogram</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>samples</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>]]]) – one Pandas dataframe or a list of Pandas DataFrame
or a series of numbers or a list of them</p></li>
<li><p><strong>column</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – name of the columns to plot, in the case one of the
sample given is a full dataframe from which we must only select
one column</p></li>
<li><p><strong>low</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>]) – low limit of the distribution
(only if <code class="docutils literal notranslate"><span class="pre">bins</span></code> is not the array of bin edges)</p></li>
<li><p><strong>high</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>]) – high limit of the distribution
(only if <code class="docutils literal notranslate"><span class="pre">bins</span></code> is not the array of bin edges)</p></li>
<li><p><strong>bins</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>]) – Desired number of bins of the histogram,
or bin edges</p></li>
<li><p><strong>weights</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>]) – weights passed
to  <code class="xref py py-func docutils literal notranslate"><span class="pre">np.histogram()</span></code>, or name of a column
in the dataframes of <code class="docutils literal notranslate"><span class="pre">samples</span></code></p></li>
<li><p><strong>density</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">bool</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>, <code class="xref py py-obj docutils literal notranslate"><span class="pre">None</span></code>]) – 3 kinds of normalisation are possible</p></li>
<li><p><strong>candidates</strong> (<em>*</em>) – just divide by the total number of counts</p></li>
<li><p><strong>bin_width</strong> (<em>*</em>) – just divide by the bin width (pretty weird)</p></li>
<li><p><strong>both</strong> (<em>*</em>) – divide by the total number of counts and by the             bin width</p></li>
<li><p><strong>equal_yield_bins</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>) – whether to use equal-yield bins</p></li>
<li><p><strong>**kwargs</strong> – passed to <code class="xref py py-func docutils literal notranslate"><span class="pre">HEA.tools.dist.get_counts_err()</span></code></p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">Tuple</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>], <code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>], <code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><ul class="simple">
<li><p>list_counts: list of bin counts for each sample in <code class="docutils literal notranslate"><span class="pre">samples</span></code></p></li>
<li><p>list_err: list of uncertainties on bin counts for each sample             in <code class="docutils literal notranslate"><span class="pre">samples</span></code></p></li>
<li><p>edges: common bin edges of all the histograms</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_hist.get_bin_width">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_hist.</span></span><span class="sig-name descname"><span class="pre">get_bin_width</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">low</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">high</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nb_bins</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_hist.html#get_bin_width"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_hist.get_bin_width" title="Permalink to this definition"></a></dt>
<dd><p>Return the bin width of the histogram (assuming equal-width bins!)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>low</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>) – low value of the histogram</p></li>
<li><p><strong>high</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>) – high value of the histogram</p></li>
<li><p><strong>nb_bins</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>) – number of bins</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Width of the bins</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>bin_width</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_hist.get_centres_edges_from_bins">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_hist.</span></span><span class="sig-name descname"><span class="pre">get_centres_edges_from_bins</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">bins</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nb_bins</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_hist.html#get_centres_edges_from_bins"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_hist.get_centres_edges_from_bins" title="Permalink to this definition"></a></dt>
<dd><p>Assuming bins are either the bin centres or the bin edges,
and given the number of bins in the histogram, return the bin
centres and edges of the histogram.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>bins</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>) – bin centres or bin edges</p></li>
<li><p><strong>nb_bins</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>) – number of bins in the histogram (usually obtained from
the array of bin counts)</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>bin centres and edges</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_hist.get_centres_from_edges">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_hist.</span></span><span class="sig-name descname"><span class="pre">get_centres_from_edges</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">edges</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_hist.html#get_centres_from_edges"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_hist.get_centres_from_edges" title="Permalink to this definition"></a></dt>
<dd><p>Get the bin centres of a histogram from the bin edges.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>edges</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>) – Bin edges of a histogram</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>Bin centres of the histogram</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_hist.get_counts_err">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_hist.</span></span><span class="sig-name descname"><span class="pre">get_counts_err</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">sample</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">bins</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">weights</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">low</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">high</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">density</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">equal_yield_bins</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_hist.html#get_counts_err"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_hist.get_counts_err" title="Permalink to this definition"></a></dt>
<dd><p>Get bin counts and errors of a list of values using
<code class="xref py py-func docutils literal notranslate"><span class="pre">numpy.histogram()</span></code></p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>sample</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>]) – sample for which we want to build a histogram</p></li>
<li><p><strong>bins</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>]) – number of bins or bin edges</p></li>
<li><p><strong>weights</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>]) – weights of each element in data</p></li>
<li><p><strong>low</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>]) – low limit of the distribution
(only if <code class="docutils literal notranslate"><span class="pre">bins</span></code> is not the array of bin edges)</p></li>
<li><p><strong>high</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>]) – high limit of the distribution
(only if <code class="docutils literal notranslate"><span class="pre">bins</span></code> is not the array of bin edges)</p></li>
<li><p><strong>density</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">bool</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>, <code class="xref py py-obj docutils literal notranslate"><span class="pre">None</span></code>]) – 3 kinds of normalisation are possible</p></li>
<li><p><strong>candidates</strong> (<em>*</em>) – just divide by the total number of counts</p></li>
<li><p><strong>bin_width</strong> (<em>*</em>) – just divide by the bin width (pretty weird)</p></li>
<li><p><strong>both</strong> (<em>*</em>) – divide by the total number of counts and by the bin width</p></li>
<li><p><strong>equal_yield_bins</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">bool</span></code>) – whether to use equal-yield bins. in this case,
<code class="docutils literal notranslate"><span class="pre">bins</span></code> must be the number of bins.</p></li>
<li><p><strong>**kwargs</strong> – passed to <code class="docutils literal notranslate"><span class="pre">np.histogram</span></code></p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">Tuple</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><ul class="simple">
<li><p>counts : number of counts in each bin</p></li>
<li><p>edges : bin edges</p></li>
<li><p>err : Errors in the counts of each bin</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_hist.get_edges_from_centres">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_hist.</span></span><span class="sig-name descname"><span class="pre">get_edges_from_centres</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">centres</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_hist.html#get_edges_from_centres"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_hist.get_edges_from_centres" title="Permalink to this definition"></a></dt>
<dd><p>Get the bin edges of a histogram from the bin centres. The bins are
supposed to be equal-sized.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>centres</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>) – Bin centres of a histogram</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Bin edges of the histogram</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_hist.get_equal_yield_bins_counts">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_hist.</span></span><span class="sig-name descname"><span class="pre">get_equal_yield_bins_counts</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">data</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">weights</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">q</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_hist.html#get_equal_yield_bins_counts"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_hist.get_equal_yield_bins_counts" title="Permalink to this definition"></a></dt>
<dd><p>Compute the bin edges of equal-yield bins. Taken from
<a class="reference external" href="https://stackoverflow.com/questions/45528029/python-how-to-create-weighted-quantiles-in-pandas">https://stackoverflow.com/questions/45528029/python-how-to-create-weighted-quantiles-in-pandas</a></p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>data</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>) – array of values</p></li>
<li><p><strong>weights</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>) – array of weights for the values in <code class="docutils literal notranslate"><span class="pre">data</span></code></p></li>
<li><p><strong>q</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>) – number of bins</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">Tuple</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>bin counts and edges</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_hist.normalise_counts_err">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_hist.</span></span><span class="sig-name descname"><span class="pre">normalise_counts_err</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">counts</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">bin_width</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">err</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">density</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'candidates'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_hist.html#normalise_counts_err"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_hist.normalise_counts_err" title="Permalink to this definition"></a></dt>
<dd><p>Normalise arrays of bins counts and errors on counts.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>counts</strong> (<em>np.ndarray</em>) – counts on a histogam</p></li>
<li><p><strong>bin_width</strong> (<em>*</em>) – bin width of the histogram.</p></li>
<li><p><strong>err</strong> (<em>np.array</em>) – count errors</p></li>
<li><p><strong>density</strong> (<em>str</em><em> or </em><em>False/None</em>) – 3 kinds of normalisation are possible</p></li>
<li><p><strong>candidates</strong> (<em>*</em>) – just divide by the total number of counts</p></li>
<li><p><strong>bin_width</strong> – just divide by the bin width (pretty weird)</p></li>
<li><p><strong>both</strong> (<em>*</em>) – divide by the total number of counts and             by the bin width</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-data docutils literal notranslate"><span class="pre">Tuple</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>]]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><ul class="simple">
<li><p>normalised_counts: normalised bin counts</p></li>
<li><p>normalised_err: normalised bin errors (only if  <code class="docutils literal notranslate"><span class="pre">err</span></code> was             given)</p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="module-lib.handle.handle_list">
<span id="lib-handle-handle-list-module"></span><h2>lib.handle.handle_list module<a class="headerlink" href="#module-lib.handle.handle_list" title="Permalink to this heading"></a></h2>
<p>Module to handle lists.</p>
<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_list.check_list_in_list">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_list.</span></span><span class="sig-name descname"><span class="pre">check_list_in_list</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">list1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list2</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_list.html#check_list_in_list"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_list.check_list_in_list" title="Permalink to this definition"></a></dt>
<dd><p>Check if <code class="docutils literal notranslate"><span class="pre">list1</span></code> is in <code class="docutils literal notranslate"><span class="pre">list2</span></code></p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>list1</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">list</span></code>) – a list</p></li>
<li><p><strong>list2</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">list</span></code>) – a list</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">bool</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>whether <code class="docutils literal notranslate"><span class="pre">list1</span></code> is in <code class="docutils literal notranslate"><span class="pre">list2</span></code></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_list.el_to_list">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_list.</span></span><span class="sig-name descname"><span class="pre">el_to_list</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">el</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">len_list</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_list.html#el_to_list"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_list.el_to_list" title="Permalink to this definition"></a></dt>
<dd><p>Turn a single non-list element <code class="docutils literal notranslate"><span class="pre">el</span></code> into a list
of size <code class="docutils literal notranslate"><span class="pre">len_list</span></code> by duplicating.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>el</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code>) – element</p></li>
<li><p><strong>len_list</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>) – length of the list to create</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>If <code class="docutils literal notranslate"><span class="pre">el</span></code> is a <code class="docutils literal notranslate"><span class="pre">list</span></code>, just returns <code class="docutils literal notranslate"><span class="pre">el</span></code>.         Else, returns list of size <code class="docutils literal notranslate"><span class="pre">len_list</span></code>, i.e., <code class="docutils literal notranslate"><span class="pre">[el,</span> <span class="pre">el,</span> <span class="pre">...]</span></code></p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>A function taking two variables might have arguments that need to be
a 2-list, whose elements correspond to the two variables.
This function allows for the user to specify only a common element
that will be converted into a 2-list.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_list.remove_list_from_list">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_list.</span></span><span class="sig-name descname"><span class="pre">remove_list_from_list</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">main_list</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">sub_list</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_list.html#remove_list_from_list"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_list.remove_list_from_list" title="Permalink to this definition"></a></dt>
<dd><p>Remove a list from a list. Not in-place.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>main_list</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">list</span></code>) – a list</p></li>
<li><p><strong>sub_list</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">list</span></code>) – a list</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">list</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><code class="docutils literal notranslate"><span class="pre">main_list</span></code> without the elements in <code class="docutils literal notranslate"><span class="pre">sub_list</span></code></p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="module-lib.handle.handle_sample">
<span id="lib-handle-handle-sample-module"></span><h2>lib.handle.handle_sample module<a class="headerlink" href="#module-lib.handle.handle_sample" title="Permalink to this heading"></a></h2>
<p>Module ot handle samples (e.g., pandas dataframe)</p>
<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_sample.compute_columns">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_sample.</span></span><span class="sig-name descname"><span class="pre">compute_columns</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataframe</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">list_columns</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_sample.html#compute_columns"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_sample.compute_columns" title="Permalink to this definition"></a></dt>
<dd><p>Compute new columns defined with a function. Their names must
be in the following format: <code class="docutils literal notranslate"><span class="pre">{function_name}|{column}</span></code>. In-place.
The functions are defined in the <code class="xref py py-mod docutils literal notranslate"><span class="pre">config</span></code> module, in the
dictionnary <code class="docutils literal notranslate"><span class="pre">DICT_FCTS</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataframe</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – sample</p></li>
<li><p><strong>list_columns</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>], <code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – list of columns to compute. The column names must
contain a <code class="docutils literal notranslate"><span class="pre">|</span></code> character.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_sample.compute_low_high">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_sample.</span></span><span class="sig-name descname"><span class="pre">compute_low_high</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">samples</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">low</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">high</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_sample.html#compute_low_high"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_sample.compute_low_high" title="Permalink to this definition"></a></dt>
<dd><p>if low or high is/are not given, compute it/them.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>samples</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">ndarray</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">Series</span></code>]]]) – sample or list of samples</p></li>
<li><p><strong>low</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>]) – low value of the range</p></li>
<li><p><strong>high</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>]) – high value of the range</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">Tuple</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>low and high values of the samples, computed if not already computed.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_sample.merge_columns">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_sample.</span></span><span class="sig-name descname"><span class="pre">merge_columns</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataframe</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">columns</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">merged_column</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_sample.html#merge_columns"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_sample.merge_columns" title="Permalink to this definition"></a></dt>
<dd><p>Merge columns of a dataframe, into one column, consisting of
the values of the columns in a tuple. In-place.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataframe</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">DataFrame</span></code>) – data sample</p></li>
<li><p><strong>columns</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – list of column names to merge</p></li>
<li><p><strong>merged_column</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – name of the resulting column</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="module-lib.handle.handle_str">
<span id="lib-handle-handle-str-module"></span><h2>lib.handle.handle_str module<a class="headerlink" href="#module-lib.handle.handle_str" title="Permalink to this heading"></a></h2>
<p>Module to handle strings.</p>
<dl class="py data">
<dt class="sig sig-object py" id="lib.handle.handle_str.DICT_FORMAT_STYLES">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_str.</span></span><span class="sig-name descname"><span class="pre">DICT_FORMAT_STYLES</span></span><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">{'float':</span> <span class="pre">'.2f',</span> <span class="pre">'int':</span> <span class="pre">',',</span> <span class="pre">'ufloat':</span> <span class="pre">'.1u',</span> <span class="pre">'ufloat_small':</span> <span class="pre">'.2ue'}</span></em><a class="headerlink" href="#lib.handle.handle_str.DICT_FORMAT_STYLES" title="Permalink to this definition"></a></dt>
<dd><p>Associates a predefined style with the corresponding format</p>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="lib.handle.handle_str.MyFormatter">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">lib.handle.handle_str.</span></span><span class="sig-name descname"><span class="pre">MyFormatter</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">default</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'{{{0}}}'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_str.html#MyFormatter"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_str.MyFormatter" title="Permalink to this definition"></a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">Formatter</span></code></p>
<p>Class used for formatting not all the arguments of a string.
Taken from
<a class="reference external" href="https://stackoverflow.com/questions/17215400/format-string-unused-named-arguments">https://stackoverflow.com/questions/17215400/format-string-unused-named-arguments</a></p>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">fmt</span><span class="o">=</span><span class="n">MyFormatter</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">fmt</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">{a}{b}</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">a</span><span class="o">=</span><span class="s2">&quot;blabla&quot;</span><span class="p">)</span>
<span class="go">&#39;blabla{b}&#39;</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="lib.handle.handle_str.MyFormatter.get_value">
<span class="sig-name descname"><span class="pre">get_value</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">key</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">args</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_str.html#MyFormatter.get_value"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_str.MyFormatter.get_value" title="Permalink to this definition"></a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_str.concatenate_str">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_str.</span></span><span class="sig-name descname"><span class="pre">concatenate_str</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">*</span></span><span class="n"><span class="pre">args</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">sep</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'</span> <span class="pre">'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">default</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_str.html#concatenate_str"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_str.concatenate_str" title="Permalink to this definition"></a></dt>
<dd><p>Concatenate a list of strings, using <code class="docutils literal notranslate"><span class="pre">sep</span></code> as separator. Remove
<code class="docutils literal notranslate"><span class="pre">None</span></code> values and convert possible non-string values (such as int, …)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>*args</strong> – strings or object that can be converted into strings, or             <code class="docutils literal notranslate"><span class="pre">None</span></code></p></li>
<li><p><strong>sep</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – Separator between strings</p></li>
<li><p><strong>default</strong> – what to return if no non-None arguments are given</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>strings concatenated with the separator <code class="docutils literal notranslate"><span class="pre">str</span></code></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_str.get_list_wildcards">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_str.</span></span><span class="sig-name descname"><span class="pre">get_list_wildcards</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">string</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_str.html#get_list_wildcards"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_str.get_list_wildcards" title="Permalink to this definition"></a></dt>
<dd><p>Find the “wildcards” of a string.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>string</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – string with wildcards</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">List</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>list of the wildcards (string inside curly brackets) of <code class="docutils literal notranslate"><span class="pre">string</span></code></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_str.numeral_into_str">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_str.</span></span><span class="sig-name descname"><span class="pre">numeral_into_str</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">variable</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">style</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_str.html#numeral_into_str"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_str.numeral_into_str" title="Permalink to this definition"></a></dt>
<dd><p>Transform a number into a string with the style given by <code class="docutils literal notranslate"><span class="pre">style</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>variable</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Union</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">float</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">ufloat</span></code>]) – numeral</p></li>
<li><p><strong>style</strong> (<code class="xref py py-data docutils literal notranslate"><span class="pre">Optional</span></code>[<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>]) – formatting style. If not given, tries to determine it</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>variable in str, using the formatting style given by <code class="docutils literal notranslate"><span class="pre">style</span></code></p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>Style aliases are given by <code class="docutils literal notranslate"><span class="pre">DICT_FORMAT_STYLES</span></code></p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_str.turn_into_latex_friendly">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_str.</span></span><span class="sig-name descname"><span class="pre">turn_into_latex_friendly</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">string</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_str.html#turn_into_latex_friendly"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_str.turn_into_latex_friendly" title="Permalink to this definition"></a></dt>
<dd><p>Replace <cite>_</cite> by <code class="docutils literal notranslate"><span class="pre">\_</span></code> in a <code class="docutils literal notranslate"><span class="pre">string</span></code> to avoid latex errors
with matplotlib</p>
<dl class="field-list simple">
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code></p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_str.ufloat_into_latex">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_str.</span></span><span class="sig-name descname"><span class="pre">ufloat_into_latex</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">ufloat_var</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">style</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'ufloat'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">with_dollar</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_str.html#ufloat_into_latex"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_str.ufloat_into_latex" title="Permalink to this definition"></a></dt>
<dd><p>Turn an ufloat into a latex string</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ufloat_var</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">ufloat</span></code>) – ufloat variable</p></li>
<li><p><strong>style</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – formatting style (if we want 2 significative numbers for
the error, etc.)</p></li>
<li><p><strong>with_dollar</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">bool</span></code>) – whether to put the string in between <cite>$</cite> signs</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>ufloat in latex format, without the <code class="docutils literal notranslate"><span class="pre">$</span></code>.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="lib.handle.handle_str.ufloat_str_into_latex">
<span class="sig-prename descclassname"><span class="pre">lib.handle.handle_str.</span></span><span class="sig-name descname"><span class="pre">ufloat_str_into_latex</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">ufloat_str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">with_dollar</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/lib/handle/handle_str.html#ufloat_str_into_latex"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#lib.handle.handle_str.ufloat_str_into_latex" title="Permalink to this definition"></a></dt>
<dd><p>Turn a raw ufloat string into an ufloat string in latex format:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">'+/-'</span></code> turned into <code class="docutils literal notranslate"><span class="pre">'\pm'</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">'e...'</span></code> turned into <code class="docutils literal notranslate"><span class="pre">'\times</span> <span class="pre">10^{...}'</span></code></p></li>
</ul>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ufloat_string</strong> – output of :py:func`str` of a ufloat</p></li>
<li><p><strong>with_dollar</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">bool</span></code>) – whether to put the string in between <code class="docutils literal notranslate"><span class="pre">$</span></code> signs</p></li>
</ul>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p><code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code></p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>ufloat in latex format</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="lib.fit.html" class="btn btn-neutral float-left" title="lib.fit package" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="lib.inout.html" class="btn btn-neutral float-right" title="lib.inout package" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>